
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>工厂模式：简单工厂模式、工厂方法模式和抽象工厂模式 / 憋错料</title>

    <meta name="description" content="工厂模式：简单工厂模式、工厂方法模式和抽象工厂模式 我们一般制造对象时,采用操作符new来进行创建.但是慢慢我们了解到实例化这个活动不应该总是公开地进行,同时初始化还经常造成&quot;耦合&quot;的问题. 如果我们不希望出现上述问题,那么我们就有必要认识一下&quot;工厂模式&quot;,它将有助于我们从复杂的依赖中解脱出来. 1)为什么说&quot;new&quot;不好? 当看到&quot;new&quot;,就会想到&quot;具体&quot;. 我们不应该总是针对实现编程,但是当我们每次使用new时,正是在针对实现编程而不是接口, ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">工厂模式：简单工厂模式、工厂方法模式和抽象工厂模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>我们一般制造对象时，采用操作符new来进行创建。但是慢慢我们了解到实例化这个活动不应该总是公开地进行，同时初始化还经常造成“耦合”的问题。</strong></p>
<p><strong>如果我们不希望出现上述问题，那么我们就有必要认识一下“工厂模式”，它将有助于我们从复杂的依赖中解脱出来。</strong></p>
<p><strong>1）为什么说“new”不好？</strong></p>
<hr>
<br /><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTQ5NjMyODAyLnBuZw==.jpg"></strong></p>
<p><strong>当看到“new”，就会想到“具体”。</strong></p>
<p><strong>我们不应该总是针对实现编程，但是当我们每次使用new时，正是在针对实现编程而不是接口，这很不符合我们的期望。</strong></p>
<p><strong>当使用“new”时，我们的确是在实例化一个具体类，当代码绑着具体类会导致代码更脆弱，更缺乏弹性。</strong></p>
<p><strong>当看到这样的代码，一旦有变化或扩展，就必须重新打开这段代码进行检查和修改。通常这样修改过的代码将造成部分系统更难维护和更新，而且也更容易犯错。</strong></p>
<p><strong>针对接口编程，可以隔离掉以后系统可能发生的一大堆改变。</strong></p>
<p><strong>&nbsp;2）我们现在建立一个拥有多种披萨类型的披萨店</strong></p>
<hr>
<br /><strong>&nbsp;通常，我们为了让系统有弹性，我们将各种类型的披萨都继承于一个抽象类或接口。（但是这样做会导致这些类或者接口无法直接实例化）</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTQ5OTAyMzQ0LnBuZw==.jpg"></strong></p>
<p><strong>这么编程，我们就会承受一些压力，这些压力来自于增加或删除比萨类型</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUwMTA0NTAwLnBuZw==.jpg"></strong></p>
<p><strong>这时候，我们想到回到OO设计原则去寻找线索。我们发现这么一条“找出会变化的方面，把它们从不变的部分分离出来”。</strong></p>
<p><strong>那么，现在我们最好将创建对象移到orderPizza()之外，这就需要把创建披萨的代码移到另一个对象中，由这个对象专职创建披萨。</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUwMjU3ODI2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUwNDQzMzgwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUwNTM4MTExLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUwNzA2MDg2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUwODMxMDkxLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUwOTExMTcyLnBuZw==.jpg"></strong></p>
<p><strong>3）定义简单工厂</strong></p>
<hr>
<br /><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxMDQzOTg5LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxMTA0NTM5LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxMjc2NDIwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxNDUyMjA4LnBuZw==.jpg"></strong></p>
<p><strong>4）工厂方法模式</strong></p>
<hr>
<br /><strong>&nbsp;</strong></p>
<p><strong>现在我们为上述我们建立的披萨店开设加盟店。</strong></p>
<p><strong>我们希望每个加盟店有自己独特的风味，但是为了保证品牌的一致性，虽然风味可以不同，但披萨的制作流程火候必须一致。</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxNTEwODA0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxNTk4Njk4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxNjQ5NDgxLnBuZw==.jpg"></strong></p>
<p><strong>甚至我们可以上不想子类覆盖的方法orderPizza（）声明成final。</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxNzIzNzAzLnBuZw==.jpg"></strong></p>
<p><strong>开一家披萨店，举个例子。</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxODM2OTg5LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUxOTYzOTQ3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyMDA2OTE3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyMDg1MDQ1LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyMTYyMTk2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyMjU1OTUwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyMzAwODc0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyNDEzMTgzLnBuZw==.jpg"></strong></p>
<p><strong>实现一个独特风味的披萨，举个例子。</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyNDc1Njg1LnBuZw==.jpg"></strong></p>
<p><strong>调用，测试一下。</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyNTkyODc3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyNjg3NjA3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyNzMzNTA3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyODAxODY5LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUyODk2NjAwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUzMDA1OTc5LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUzMDYwNjY4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUzMTgxNzY3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUzMjkyMTIzLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUzMzU4NTMxLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUzNjE3MzMwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUzNzg2MjgyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTUzOTQzNTE1LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0MTA0NjU0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0MTY4MTMzLnBuZw==.jpg"></strong></p>
<p><strong>5）依赖倒置原则</strong></p>
<hr>
<br /><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0MjY1NzkzLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0Mzc5MDc4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0NDMwODM4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0NDg4NDU4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0NTkzOTMwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0NjI5MDg4LnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0NzA0Mjg2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0NzQ3MjU3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0ODAxOTQ2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0ODM3MTA0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU0OTg3NTAwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1MTEzNDgyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1MTcwMTI0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1MjYwOTQ4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1MzQyMDA2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1MzgyMDQ3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1NDIzMDY0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1NDcyODcwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1NTY0NjcxLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1NjIwMzM3LnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1Njk0NTU5LnBuZw==.jpg"></strong></p>
<p><strong>&nbsp;</strong></p>
<p><strong>&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1NzkwMjY1LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1ODg4OTAyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU1OTU0MzM0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2MTEwNTkwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2MjAzMzY3LnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2MjQ4MjkxLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2Mjk3MTIxLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2NDIwMTcyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2NDk2MzQ3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2NTU0OTQzLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2NTk4ODkwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2NzIwOTY1LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2NzcwNzcyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2ODM2MjA0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU2OTYzMTYyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3MDE0OTIyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3MDkwMTIwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3MTg0ODUwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3Mjc3NjI3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3MzQzMDU5LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3NTA0MTk4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3NTQwMzMzLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3NTg5MTYzLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3NjU3NTI1LnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3NzEyMjE0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3NzcxNzg3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3ODcwNDIzLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU3OTU5Mjk0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4MDEzMDA3LnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4MDk0MDY1LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4MTI4MjQ2LnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4MTgwOTgyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4MjE2MTQwLnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4MjUwMzIxLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4MjkzMjkxLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4MzM0MzA4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4NDAwNzE3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4NDY5MDc5LnBuZw==.jpg"></strong></p>
<p><strong>6）抽象工厂模式</strong></p>
<hr>
<br /><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4NTQ3MjA3LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4NjU4NTQwLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4NzU2MjAwLnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4ODM4MjM0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU4ODc1MzQ1LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5MDcyNjE4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5MjE3MTU1LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5MzQ5OTcyLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5NDMwMDU0LnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5NDkxNTc5LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5NTU3OTg4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5NjM2MTE2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5NjkyNzU5LnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5ODEwOTI4LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5ODYxNzExLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5OTI5MDk2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMTU5OTc1OTczLnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMjAwMDcyNjU2LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMjAwMTYyNTA0LnBuZw==.jpg"></strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2UubWFtaWNvZGUuY29tL2luZm8vMjAxODA2LzIwMTgwNjAyMTgxMjAwMzI0NjE5LnBuZw==.jpg"></strong></p>
<p><strong>7）小结</strong></p>
<hr>
<br /><strong>&nbsp;OO基础：</strong></p>
<ul>
<li><strong>抽象</strong></li>
<li><strong>封装</strong></li>
<li><strong>多态</strong></li>
<li><strong>继承&nbsp;</strong></li>
</ul>
<p><strong>&nbsp;</strong></p>
<p><strong>OO原则：</strong></p>
<ul>
<li><strong>封装变化</strong></li>
<li><strong>多用组合、少用继承</strong></li>
<li><strong>针对接口编程，不针对实现编程</strong></li>
<li><strong>为交互对象之间的松耦合设计而努力</strong></li>
<li><strong>对扩展开放，对修改关闭</strong></li>
<li><strong>依赖抽象，不要依赖具体类</strong></li>
</ul>
<p><strong>&nbsp;</strong></p>
<p><strong>OO模式：</strong></p>
<ul>
<li><strong>策略模式——定义算法族，分别封装起来，让它们之间可以互相替换，此模式让算法的变化独立于使用算法的客户</strong></li>
<li><strong>观察者模式——在对象之间定义一对多的依赖，这样一来，当一个对象改变状态，依赖它的对象都会收到通知，并自动更新</strong></li>
<li><strong>装饰者模式——动态地将责任附加到对象上。想要扩展功能，装饰者提供有别于继承的一种选择</strong></li>
<li><strong>抽象工厂模式——提供一个接口，用于创建相关或依赖对象的家族，而不需要明确指定具体类</strong></li>
<li><strong>工厂方法模式——定义了一个创建对象的接口，但由于子类决定要实例化的类是哪一个。工厂方法让类把实例化推迟到子类</strong></li>
</ul>
<p><strong>&nbsp;</strong></p>
<p><strong>要点：</strong></p>
<ul>
<li><strong>&nbsp;所有的工厂都是用来封装对象的创建</strong></li>
<li><strong>简单工厂，虽然不是真正的设计模式，但仍不失为一个简单的方法，可以将客户程序从具体类解耦</strong></li>
<li><strong>工厂方法使用继承：把对象的创建委托给子类，子类实现工厂方法来创建对象</strong></li>
<li><strong>抽象工厂使用对象组合：对象的创建被实现在工厂接口所暴露出来的方法中</strong></li>
<li><strong>所有工厂模式都通过减少应用程序和具体类之间的依赖促进松耦合</strong></li>
<li><strong>工厂方法允许类将实例化延迟到子类进行</strong></li>
<li><strong>抽象工厂创建相关的对象家族，而不需要依赖它们的具体类</strong></li>
<li><strong>依赖倒置原则，指导我们避免依赖具体类型，而要尽量依赖抽象</strong></li>
<li><strong>工厂是很有威力的技巧，帮助我们针对抽象编程，而不是针对具体类编程</strong></li>
</ul>
<p><strong>参考书目：《Head First 设计模式》</strong></p>
<p><strong>&nbsp;</strong></p>

<p>原文地址：https://www.cnblogs.com/dudududu/p/9126073.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 18:35:59 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e5%85%81%e8%ae%b8/" title="允许">允许</a>, <a href="https://www.biecuoliao.com/tag/ima/" title="ima">ima</a>, <a href="https://www.biecuoliao.com/tag/%e5%bc%80%e6%94%be/" title="开放">开放</a>, <a href="https://www.biecuoliao.com/tag/%e4%b9%8b%e9%97%b4/" title="之间">之间</a>, <a href="https://www.biecuoliao.com/tag/inf/" title="inf">inf</a>, <a href="https://www.biecuoliao.com/tag/%e6%8a%bd%e8%b1%a1/" title="抽象">抽象</a>, <a href="https://www.biecuoliao.com/tag/%e5%b0%b1%e4%bc%9a/" title="就会">就会</a>, <a href="https://www.biecuoliao.com/tag/%e5%b7%a5%e5%8e%82%e6%96%b9%e6%b3%95/" title="工厂方法">工厂方法</a>, <a href="https://www.biecuoliao.com/tag/%e7%ae%97%e6%b3%95%e6%97%8f/" title="算法族">算法族</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>工厂模式：简单工厂模式、工厂方法模式和抽象工厂模式的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWKOAaM.html" rel="bookmark">《Head first设计模式》之抽象工厂</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				抽象工厂模式提供一个接口,用于创建相关或依赖对象的家族,而不需要明确指定具体类. 确保原料的一致 披萨店成功的关键在于新鲜.高质量的原料.要如何确保每家加盟店使用高质量的原料?你打算建造一家生成原料的工厂,并将原料运送到各家加盟店.对于这个做法,现在还剩下一个问题:加盟店坐落在不同的区域,纽约的红酱料和芝加哥的红酱料是不一样的.加盟店之间有相同的产品家族(意式腊肠.酱料.芝士.蔬菜等等),但是制作方式根据区域的不同而有差异.所以对于纽约和芝加哥,你准备了两组不同的原料.假如不久之后加州就有加盟店			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm1GbpM.html" rel="bookmark">结合实例分析简单工厂模式&amp;amp&semi;工厂方法模式&amp;amp&semi;抽象工厂模式的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前写过一篇关于工厂模式(Factory Pattern)的随笔,里面分析了简单工厂模式,但对于工厂方法和抽象工厂的分析较为简略.这里重新分析分析三者的区别,工厂模式是java设计模式中比较简单的一个设计模式,但很多地方都用到了工厂模式,(如解析xml中,jdbc连接数据库等)利用好工厂模式对程序的设计很有用处.工厂模式在一些设计模式的书中分为简单工厂模式,工厂方法模式和抽象工厂模式三类.也有把工厂方法模式划分到抽象工厂模式的,认为工厂方法是抽象工厂模式的特例的一种,就是只有一个要实现的产品接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXjda83.html" rel="bookmark">简单工厂和工厂方法以及抽象工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				工厂模式:定义一个用于创建对象的借口,让子类决定实例化哪一个类 抽象工厂模式:为创建一组相关或相互依赖的对象提供一个接口,而且无需指定他们的具体类 个人觉得这个区别在于产品,如果产品单一,最合适用工厂模式,但是如果有多个业务品种.业务分类时,通过抽象工厂模式产生需要的对象是一种非常好的解决方 式.再通俗深化理解下:工厂模式针对的是一个产品等级结构 ,抽象工厂模式针对的是面向多个产品等级结构的. 再来看看工厂方法模式与抽象工厂模式对比: 工厂方法模式 抽象工厂模式 针对的是一个产品等级结构 针对的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0Rqr9RM.html" rel="bookmark">简单工厂模式&comma;工厂方法模式&comma;抽象工厂模式&comma;spring的狂想</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				菜鸟D在项目中遇见一个比较纠结的高耦合,所以就想办法来解耦.情况是这样的:系统通过用户选择treeview控件的节点判断调用不同的处理,这些处理中某些东西又是类似的.同事的建议是采用简单工厂,耦合就耦合吧,反正treeview节点基本是不会变化的.(能偷懒就偷懒吧) 菜鸟D有些偏执,想找些方法来解耦.于是就学习了这个几种方法,虽然不一定用的上,多学一点总是好的. 首先说简单工厂,例子是一个已经二到死的计算器. 简单工厂由三种角色组成:工厂类角色(creator),抽象产品类角色(product,			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qAkaP3.html" rel="bookmark">设计模式&lpar;Python&rpar;-简单工厂，工厂方法和抽象工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本系列文章是希望将软件项目中最常见的设计模式用通俗易懂的语言来讲解清楚,并通过Python来实现,每个设计模式都是围绕如下三个问题: 为什么?即为什么要使用这个设计模式,在使用这个模式之前存在什么样的问题? 是什么?通过Python语言来去实现这个设计模式,用于解决为什么中提到的问题. 怎么用?理解了为什么我们也就基本了解了什么情况下使用这个模式,不过在这里还是会细化使用场景,阐述模式的局限和优缺点. 这次的主角是简单工厂,工厂方法和抽象工厂模式,由于这几个模式联系紧密,有一定的相似性,所以放在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e1Rag0.html" rel="bookmark">简单工厂模式&amp;amp&semi;工厂方法模式&amp;amp&semi;抽象工厂模式的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前写过一篇关于工厂模式(Factory Pattern)的随笔,里面分析了简单工厂模式,但对于工厂方法和抽象工厂的分析较为简略.这里重新分析分析三者的区别,工厂模式是java设计模式中比较简单的一个设计模式,但很多地方都用到了工厂模式,(如解析xml中,jdbc连接数据库等)利用好工厂模式对程序的设计很有用处.工厂模式在一些设计模式的书中分为简单工厂模式,工厂方法模式和抽象工厂模式三类.也有把工厂方法模式划分到抽象工厂模式的,认为工厂方法是抽象工厂模式的特例的一种,就是只有一个要实现的产品接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/x0d5YZ3.html" rel="bookmark">Java设计模式&mdash;工厂方法模式&amp;amp&semi;抽象工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				工厂方法模式与抽象工厂模式都是设计模式中重要而且常见的模式.       工厂方法模式:定义一个用于创建对象的接口,让子类决定实例化哪一个类.工厂方法使一个类的实例化延迟到其子类. 通用类图如下: 在工厂方法模式中,抽象产品类Product负责定义产品的共性,实现对事物最抽象的定义:Creator为抽象创建 类,也就是抽象工厂,具体如何创建产品类是由具体的实现工厂ConcreteCreator完成的. 工厂方法模式的扩展方式有很多种,下边是工厂方法模式一个比较实用的源代码: 抽象产品类: pub			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47qopD0.html" rel="bookmark">工厂方法模式And抽象工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.工厂方法模式 简单工厂模式的缺陷就是类的创建太过于依赖工厂,一旦需要进行程序扩展,就必须修改工厂类的代码 这违背了背包原则. 而工厂方法模式针对这一问题进行了改进. public interface Sender { public void send(); } public interface producer { public Sender produce(); } public class MailFactory implements producer{ public Sender pr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k99Zd4.html" rel="bookmark">2 简单工厂模式、工厂模式、抽象工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简单工厂模式: -----------------------------------Pizza.java-------------------- package com; public abstract class Pizza { public abstract void prepare(); public abstract void bake(); public abstract void cut(); } -----------------------------------APizza.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j4NeOB3.html" rel="bookmark" class="title">C语言  &amp;&num;183&semi;  十六进制转十进制</a>
					<div>
						问题描述 从键盘输入一个不超过8位的正的十六进制数字符串,将它转换为正的十进制数后输出. 注:十六进制数中的10~15分别用大写的英文字母A.B.C.D.E.F表示. 样例输入 FFFF 样例输出 6 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0ar1R3.html" rel="bookmark" class="title">《Linux内核设计与实现》第3章读书笔记</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWyegB3.html" rel="bookmark" class="title">struts2 log4j&colon;WARN Please initialize the log4j system properly&period; 解决方法</a>
					<div>
						在tomcat启动的时候,出现这个警告: log4j:WARN No appenders could be found for logger (org.apache.commons.digester. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n1d9NM.html" rel="bookmark" class="title">局域网桌面远程</a>
					<div>
						首先点击右下角的电源图标,我的没插电池会显示一个 在电源图标处点左键或右键都行,点击电源选项&gt;&gt;选择关闭盖子的功能 把这四项选为不采取任何操作&gt;&gt;保存修改 右击“这台电脑”&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5QApM.html" rel="bookmark" class="title">HDU 5974 A Simple Math Problem  &mdash;&mdash;（数论，大连区域赛）</a>
					<div>
						给大一的排位赛中数论的一题.好吧不会做...提供一个题解吧:http://blog.csdn.net/aozil_yang/article/details/53538854. 又学了一个新的公式..如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02Dr524.html" rel="bookmark" class="title">IIS7如何部署asp&period;net网站</a>
					<div>
						第一步:发布网站 右键asp.net web项目,选择发布, 然后新建配置文件名称并选择 &quot;文件系统&quot; 发布方法. 目标位置选择本地新建的文件夹如: IISWebSite 第二步: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eneEJ3.html" rel="bookmark" class="title">HTML5面试题目汇总（二）</a>
					<div>
						HTML5面试题目汇总(二) 标签: javascript 2016-07-19 10:15 639人阅读 评论(0) 收藏 举报  分类: javascript(16)  1.怎样添加.移除.移动. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dA9OB3.html" rel="bookmark" class="title">Html中的&amp;lt&semi;marquee&amp;gt&semi;标签</a>
					<div>
						marquee的属性: innerHTML:     设置或获取位于对象起始和结束标签内的 HTML scrollHeight:   获取对象的滚动高度. scrollLeft:       设置或获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Y718r4.html" rel="bookmark" class="title">&lbrack;LeetCode 题解&rsqb;&colon; Reverse Nodes in K-Groups</a>
					<div>
						Given a linked list, reverse the nodes of a linked list k at a time and return its modified list. If ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41oRqO0.html" rel="bookmark" class="title">利用CPaintDC&colon;&colon;IntersectClipRect将绘图限制在局部区域</a>
					<div>
						问题背景:画带坐标的图,例如 画里面那条曲线的时候,希望将绘图区域局限在坐标范围内,范围外的就自动屏蔽掉. 两个方案,一是用CPaintDC的SelectClipRgn函数,感觉略麻烦.另一个函数,就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPeewm0.html" rel="bookmark" class="title">C&plus;&plus;入门经典-例6&period;17-输出每行数组中的最小值</a>
					<div>
						1:代码如下: // 6.17.cpp : 定义控制台应用程序的入口点. // #include &quot;stdafx.h&quot; #include&lt;iostream&gt; using ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xABr73.html" rel="bookmark" class="title">2015年的目标</a>
					<div>
						1. Build a team 我们现在开始有4个人,可以说是一个小团队,这样的话我可以将任务分配的更合理,然后腾出更多的时间来思考团队管理这个对我来说纠结了挺久的问题.之前人太少的话,我觉得没什么管 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xAAlk3.html" rel="bookmark" class="title">XmlSerializer 生成xml文件</a>
					<div>
						1 /** 2 * XmlSerializer xml序列化器 3 */ 4 //创建xmlSerializer 5 XmlSerializer serializer = Xml.newSeriali ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoRVvD4.html" rel="bookmark" class="title">计算两个经纬度之间的距离&lpar;python算法&rpar;</a>
					<div>
						EARTH_REDIUS = 6378.137 def rad(d): return d * pi / 180.0 def getDistance(lat1, lng1, lat2, lng2): r ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0baPb9M.html" rel="bookmark" class="title">WPF VisualTreeHelper分析</a>
					<div>
						1.方法一 public static int GetChildrenCount( DependencyObject reference )可以看到接受任何为DependencyObject,wpf中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZG99L4.html" rel="bookmark" class="title">Ajax异步请求阻塞情况的解决办法</a>
					<div>
						最近使用ExtJs4的mvc模式在开发了在线漫画的后台,因为异步请求比较多,有的回应时间长,有点短.我发现在多次并发的情况下,会造成阻塞的情况.也就是说如果回应时间长的请求还在进行中,短的请求却被挂起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nbgqp0.html" rel="bookmark" class="title">【BZOJ】1441&colon; Min（裴蜀定理）</a>
					<div>
						http://www.lydsy.com/JudgeOnline/problem.php?id=1441 这东西竟然还有个名词叫裴蜀定理................ 裸题不说....&lt;初等数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGnqOQ4.html" rel="bookmark" class="title">Hive学习（七）Hive四种数据导入方式</a>
					<div>
						Hive的几种常见的数据导入方式 这里介绍四种: (1).从本地文件系统中导入数据到Hive表: (2).从HDFS上导入数据到Hive表: (3).从别的表中查询出相应的数据并导入到Hive表中:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xDGZr0.html" rel="bookmark" class="title">Java Observable 模式</a>
					<div>
						一.Observer模式的意图: 在对象的内部状态发生变化时,自动通知外部对象进行响应. 二.Observer模式的构成: ·被观察者:内部状态有可能被改变,而且又需要通知外部的对象 ·观察者:需要对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38D6Py3.html" rel="bookmark" class="title">开放平台网址</a>
					<div>
						百度开放平台:http://alading.baidu.com/ 百度地图开放平台:http://lbsyun.baidu.com/ 淘宝开放平台:http://open.taobao.com/?sp ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.041 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
